searchNodes=[{"ref":"AtEx.html","title":"AtEx","type":"module","doc":"AtEx is an Elixir Wrapper for the Africas Talking Api Use this library to handle interaction with the Africas Talking API end points, It is most useful for Consuming incoming events that have been parsed Building valid responses This is in development, currently the following parts of the API are working: SMS (Non Premium Sms) USSD Airtime Application Getting Started Configuration config :at_ex, api_key: &quot;YOURAPIKEY&quot;, content_type: &quot;application/x-www-form-urlencoded&quot;, accept: &quot;application/json&quot;, username: &quot;YOURUSERNAME&quot;"},{"ref":"AtEx.html#get_application_data/0","title":"AtEx.get_application_data/0","type":"function","doc":"Collects application data from Africas Talking endpoint, Use this function to collect Data about your application Parameters none Examples iex&gt; AtEx.get_application_data() {:ok, %{&quot;UserData&quot; =&gt; %{&quot;balance&quot; =&gt; &quot;ZAR -1.4572&quot;}}}"},{"ref":"AtEx.html#send_airtime/1","title":"AtEx.send_airtime/1","type":"function","doc":"Sends airtime ## Parameters - map: a map that represents the details of the party you are sending airtime to ## Examples iex&gt; AtEx.send_airtime(%{recipients: [%{phone_number: &quot;+254721978097&quot;, amount: &quot;KES 50&quot;}]}) {:ok, %{ &quot;errorMessage&quot; =&gt; &quot;None&quot;, &quot;numSent&quot; =&gt; 1, &quot;responses&quot; =&gt; [ %{ &quot;amount&quot; =&gt; &quot;KES 50.0000&quot;, &quot;discount&quot; =&gt; &quot;KES 2.0000&quot;, &quot;errorMessage&quot; =&gt; &quot;None&quot;, &quot;phoneNumber&quot; =&gt; &quot;+254721978097&quot;, &quot;requestId&quot; =&gt; &quot;ATQid_630557e624c70f2b0d2c5e90ebc282bb&quot;, &quot;status&quot; =&gt; &quot;Sent&quot; } ], &quot;totalAmount&quot; =&gt; &quot;ZAR 7.0277&quot;, &quot;totalDiscount&quot; =&gt; &quot;ZAR 0.2811&quot; }}"},{"ref":"AtEx.Gateway.Airtime.html","title":"AtEx.Gateway.Airtime","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API Application Data endpoint, use it to POST and GET requests to the Application endpoint"},{"ref":"AtEx.Gateway.Airtime.html#process_result/1","title":"AtEx.Gateway.Airtime.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Airtime.html#send_airtime/1","title":"AtEx.Gateway.Airtime.send_airtime/1","type":"function","doc":"Sends airtime to one or more numbers, accepts a map of parameters contaitning a list of maps each containing a phone numbers and an amount of airtime to send out to a number this is expected in the recipients key. Parameters map: map containing a recipients which is a list of maps each with a phone number and amount Examples AtEx.Gateway.Airtime.send_airtime(%{recipients: [%{phone_number: &quot;+254721978097&quot;, amount: &quot;KES 50&quot;}]})"},{"ref":"AtEx.Gateway.Airtime.html#t:call_return/0","title":"AtEx.Gateway.Airtime.call_return/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Airtime.html#t:option/0","title":"AtEx.Gateway.Airtime.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Airtime.html#t:send_input/0","title":"AtEx.Gateway.Airtime.send_input/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Application.html","title":"AtEx.Gateway.Application","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API Application Data endpoint, use it to POST and GET requests to the Application endpoint"},{"ref":"AtEx.Gateway.Application.html#get_data/0","title":"AtEx.Gateway.Application.get_data/0","type":"function","doc":"Collects application data from Africas Talking endpoint, Use this function to collect Data about your application Parameters none Examples iex&gt; AtEx.Gateway.Application.get_data() {:ok, %{&quot;UserData&quot; =&gt; %{&quot;balance&quot; =&gt; &quot;ZAR -1.3448&quot;}} }"},{"ref":"AtEx.Gateway.Application.html#process_result/1","title":"AtEx.Gateway.Application.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Application.html#t:option/0","title":"AtEx.Gateway.Application.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Base.html","title":"AtEx.Gateway.Base","type":"module","doc":"Base HTTP Gateway for AtEx.Gateway.Base"},{"ref":"AtEx.Gateway.Base.html#__using__/1","title":"AtEx.Gateway.Base.__using__/1","type":"macro","doc":"Macro to import necessary code into HTTP Gateways, This Macro accepts a list as configuration at the moment it&#39;s used configure the HTTP Base Url. Parameters list: list of parameters for HTTP client configuration Examples defmodule AtEx.Gateway.Voice do use AtEx.Gateway.Base, url: &quot;http://test.com&quot; @username &quot;some_username&quot; def collect_minutes(attrs) do params = attrs |&gt; Map.put(:username, @username) {:ok, resp} = get(&quot;/minutes&quot;, params) process_result(resp.body) end end"},{"ref":"AtEx.Gateway.Iot.PublishData.html","title":"AtEx.Gateway.Iot.PublishData","type":"module","doc":"This module allows you to make an HTTP POST to publish messages to your remote devices."},{"ref":"AtEx.Gateway.Iot.PublishData.html#process_result/1","title":"AtEx.Gateway.Iot.PublishData.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Iot.PublishData.html#publish/1","title":"AtEx.Gateway.Iot.PublishData.publish/1","type":"function","doc":"This function makes a POST request to to publish messages to your remote devices through the Africa&#39;s talking IOT endpoint The function accepts a map of parameters. Parameters attrs: - a map containing: deviceGroup - The device group to which the message is to be sent topic - The messaging channel to which the message is to be sent. In the form // payload - The message packet to be sent to the subscribed devices. Example iex&gt; AtEx.Gateway.Iot.PublishData.publish(%{ ...&gt; deviceGroup: &quot;CrazyCats&quot;, ...&gt; topic: &quot;any-topic&quot;, ...&gt; payload: &quot;take me to your leader&quot; ...&gt; }) {:ok, %{ &quot;status&quot; =&gt; true, &quot;description&quot; =&gt; &quot;Message processed successfully&quot;}}"},{"ref":"AtEx.Gateway.Iot.PublishData.html#t:option/0","title":"AtEx.Gateway.Iot.PublishData.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Bank.Checkout.html","title":"AtEx.Gateway.Payments.Bank.Checkout","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Bank Checkout API"},{"ref":"AtEx.Gateway.Payments.Bank.Checkout.html#bank_checkout/1","title":"AtEx.Gateway.Payments.Bank.Checkout.bank_checkout/1","type":"function","doc":"Bank checkout APIs allow your application to collect money into your payment wallet by initiating transactions that deduct money from a customers bank account. Config add bank_checkout_product_name key to your AtEx configs Parameters attrs: - a map containing bankAccount(a map), currencyCode, amount, narration and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Fcheckout for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Bank.Checkout.bank_checkout(%{bankAccount: %{accountName: &quot;KCB&quot;, accountNumber: &quot;93892892&quot;, bankCode: 234001}, amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, metadata: %{detail: &quot;A Bill&quot;}}) {:ok, %{ &quot;description&quot; =&gt; &quot;Payment is pending validation by the user&quot;, &quot;status&quot; =&gt; &quot;PendingValidation&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_0f4b78bf0926b4b05d131550f8fc4f2d&quot; }}"},{"ref":"AtEx.Gateway.Payments.Bank.Checkout.html#process_result/1","title":"AtEx.Gateway.Payments.Bank.Checkout.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Bank.Checkout.html#t:option/0","title":"AtEx.Gateway.Payments.Bank.Checkout.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Bank.Transfer.html","title":"AtEx.Gateway.Payments.Bank.Transfer","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Bank Transfer API"},{"ref":"AtEx.Gateway.Payments.Bank.Transfer.html#bank_transfer/1","title":"AtEx.Gateway.Payments.Bank.Transfer.bank_transfer/1","type":"function","doc":"Bank checkout validation APIs allow your application to validate bank checkout charge requests. Config add bank_transfer_product_name key to your AtEx configs Parameters attrs: - a list of recipients each containing a map with currencyCode, amount, narration and a map of metadata (optional) see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Ftransfer for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Bank.Transfer.bank_transfer([%{bankAccount: %{accountName: &quot;KCB&quot;, accountNumber: &quot;93892892&quot;, bankCode: 234001}, amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, metadata: %{detail: &quot;A Bill&quot;}}]) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;accountNumber&quot; =&gt; &quot;93892892&quot;, &quot;status&quot; =&gt; &quot;Queued&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_SampleTxnId&quot;, &quot;transactionFee&quot; =&gt; &quot;NGN 50.00&quot; } ] }}"},{"ref":"AtEx.Gateway.Payments.Bank.Transfer.html#process_result/1","title":"AtEx.Gateway.Payments.Bank.Transfer.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Bank.Transfer.html#t:option/0","title":"AtEx.Gateway.Payments.Bank.Transfer.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Bank.Validate.html","title":"AtEx.Gateway.Payments.Bank.Validate","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Bank Trabsfer Validation API"},{"ref":"AtEx.Gateway.Payments.Bank.Validate.html#bank_validate/1","title":"AtEx.Gateway.Payments.Bank.Validate.bank_validate/1","type":"function","doc":"Bank checkout validation APIs allow your application to validate bank checkout charge requests. Parameters attrs: - a map containing transactionId and otp see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Fvalidate for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Bank.Validate.bank_validate(%{transactionId: &quot;ATPid_a58b61dc2bf556ff9c4b16e9f6e40795&quot;, otp: &quot;password&quot;}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;description&quot; =&gt; &quot;Payment completed successfully&quot; }}"},{"ref":"AtEx.Gateway.Payments.Bank.Validate.html#process_result/1","title":"AtEx.Gateway.Payments.Bank.Validate.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Bank.Validate.html#t:option/0","title":"AtEx.Gateway.Payments.Bank.Validate.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Card.Checkout.html","title":"AtEx.Gateway.Payments.Card.Checkout","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Card Checkout API"},{"ref":"AtEx.Gateway.Payments.Card.Checkout.html#card_checkout/1","title":"AtEx.Gateway.Payments.Card.Checkout.card_checkout/1","type":"function","doc":"Card Checkout APIs allow your application to collect money into your Payment Wallet by initiating transactions that deduct money from a customers Debit or Credit Card. Config Add card_checkout_product_name key to your AtEx configs Parameters attrs: - a map containing either paymentCard(a map) or checkoutToken, currencyCode, amount, narration and a map of metadata(optional) see the docs at https://build.at-labs.io/docs/payments%2Fcard%2Fcheckout for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Card.Checkout.card_checkout(%{amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, paymentCard: %{number: &quot;10928873477387&quot;, cvvNumber: 253, expiryMonth: 12, expiryYear: 2020, countryCode: &quot;NG&quot;, authToken: &quot;jhdguyt6372gsu6q&quot;}}) {:ok, %{ status: &quot;PendingValidation&quot;, description: &quot;Waiting for user input&quot;, transactionId: &quot;ATPid_SampleTxnId123&quot; }}"},{"ref":"AtEx.Gateway.Payments.Card.Checkout.html#process_result/1","title":"AtEx.Gateway.Payments.Card.Checkout.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Card.Checkout.html#t:option/0","title":"AtEx.Gateway.Payments.Card.Checkout.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Card.Validate.html","title":"AtEx.Gateway.Payments.Card.Validate","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Card Validation API"},{"ref":"AtEx.Gateway.Payments.Card.Validate.html#card_validate/1","title":"AtEx.Gateway.Payments.Card.Validate.card_validate/1","type":"function","doc":"Card checkout validation APIs allow your application to validate card checkout charge requests. Parameters attrs: - a map containing transactionId and otp see the docs at https://build.at-labs.io/docs/payments%2Fcard%2Fvalidate for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Card.Validate.card_validate(%{transactionId: &quot;ATPid_SampleTxnId123&quot;, otp: &quot;password&quot;}) {:ok, %{ status: &quot;Success&quot;, description: &quot;Payment completed successfully&quot;, checkoutToken: &quot;ATCdTkn_SampleCdTknId123&quot; }}"},{"ref":"AtEx.Gateway.Payments.Card.Validate.html#process_result/1","title":"AtEx.Gateway.Payments.Card.Validate.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Card.Validate.html#t:option/0","title":"AtEx.Gateway.Payments.Card.Validate.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Mobile.B2b.html","title":"AtEx.Gateway.Payments.Mobile.B2b","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Mobile B2B API"},{"ref":"AtEx.Gateway.Payments.Mobile.B2b.html#b2b_checkout/1","title":"AtEx.Gateway.Payments.Mobile.B2b.b2b_checkout/1","type":"function","doc":"Mobile Business To Business (B2B) APIs allow you to send payments to businesses e.g banks from your Payment Wallet. Config Add b2b_product_name key to the AtEx config values Parameters attrs: - a map containing a provider(Mpesa,TigoTanzania,Athena), transferType(BusinessBuyGoods,BusinessPayBill, DisburseFundsToBusiness, BusinessToBusinessTransfer), currencyCode amount, destinationChannel, destinationAccount and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fb2b for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Mobile.B2b.b2b_checkout(%{provider: &quot;Athena&quot;, transferType: &quot;DisburseFundsToBusiness&quot;, amount: 10, currencyCode: &quot;KES&quot;, destinationChannel: &quot;Mine&quot;, destinationAccount: &quot;Mine&quot;, metadata: %{ message: &quot;I am here&quot;}}) {:ok, %{ &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;Queued&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_2504d5f5d28256fa264e815518e3ab0d&quot; }}"},{"ref":"AtEx.Gateway.Payments.Mobile.B2b.html#process_result/1","title":"AtEx.Gateway.Payments.Mobile.B2b.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Mobile.B2b.html#t:option/0","title":"AtEx.Gateway.Payments.Mobile.B2b.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Mobile.B2c.html","title":"AtEx.Gateway.Payments.Mobile.B2c","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Mobile B2C API"},{"ref":"AtEx.Gateway.Payments.Mobile.B2c.html#b2c_checkout/1","title":"AtEx.Gateway.Payments.Mobile.B2c.b2c_checkout/1","type":"function","doc":"This function initiates a mobile B2C request by making a HTTP POST request to the Africa&#39;s talking Mobile B2C endpoint. Config Add b2c_product_name key to your AtEx configs Parameters attrs: - a list of Recipient each a map containing a phoneNumber, currencyCode, amount and a map of metadata key optionally it may also contain name, reason and providerChannel see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fb2c%2Foverview for how to use these keys Example iex&gt;AtEx.Gateway.Payments.Mobile.B2c.b2c_checkout([%{phoneNumber: &quot;254724540000&quot;, amount: 10, currencyCode: &quot;KES&quot;, metadata: %{ message: &quot;I am here&quot;}}]) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;phoneNumber&quot; =&gt; &quot;+254724540000&quot;, &quot;provider&quot; =&gt; &quot;Athena&quot;, &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;Queued&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_beeb0be6b1bff57ec8f32675fe3f6e72&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; } ], &quot;numQueued&quot; =&gt; 1, &quot;totalTransactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;totalValue&quot; =&gt; &quot;KES 10.0000&quot; }}"},{"ref":"AtEx.Gateway.Payments.Mobile.B2c.html#process_result/1","title":"AtEx.Gateway.Payments.Mobile.B2c.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Mobile.B2c.html#t:option/0","title":"AtEx.Gateway.Payments.Mobile.B2c.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Mobile.Checkout.html","title":"AtEx.Gateway.Payments.Mobile.Checkout","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking Mobile Checkout API"},{"ref":"AtEx.Gateway.Payments.Mobile.Checkout.html#mobile_checkout/1","title":"AtEx.Gateway.Payments.Mobile.Checkout.mobile_checkout/1","type":"function","doc":"This function initiates a mobile checkout request by sending a HTTP POST request to the Africa&#39;s talking Mobile Checkout endpoint. Config Add stk_product_name key to your AtEx configs Parameters attrs: - a map containing a phoneNumber, currencyCode and amount key optionally it may also contain providerChannel and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fcheckout for how to use these keys Example iex&gt; AtEx.Gateway.Payments.Mobile.Checkout.mobile_checkout(%{phoneNumber: &quot;254724540000&quot;, amount: 10, currencyCode: &quot;KES&quot;}) {:ok, %{ &quot;description&quot; =&gt; &quot;Waiting for user input&quot;, &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;PendingConfirmation&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_ca3ba091736bd8502afd4376a7519cf8&quot; } }"},{"ref":"AtEx.Gateway.Payments.Mobile.Checkout.html#process_result/1","title":"AtEx.Gateway.Payments.Mobile.Checkout.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Mobile.Checkout.html#t:option/0","title":"AtEx.Gateway.Payments.Mobile.Checkout.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Query.FetchProductTransactions.html","title":"AtEx.Gateway.Payments.Query.FetchProductTransactions","type":"module","doc":"Fetch transactions of a particular payment product by sending a HTTP GET request to the following endpoint"},{"ref":"AtEx.Gateway.Payments.Query.FetchProductTransactions.html#fetch_product_transactions/1","title":"AtEx.Gateway.Payments.Query.FetchProductTransactions.fetch_product_transactions/1","type":"function","doc":"Fetch transactions of a particular payment product by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: productName - The name of the payment product whose transactions you’d like to fetch. pageNumber - The number of the page you’d like to read results from. Please Note: This STARTS from 1 and NOT 0 count - The number of transaction results you would like for this query. Must be &gt; 1 and &lt; 1,000 and optional parameters startDate, endDate, category, provider, status, source, destination and providerChannel For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffetch_product_transactions Example iex&gt;AtEx.Gateway.Payments.Query.FetchProductTransactions.fetch_product_transactions(%{productName: &quot;AtEx&quot;, pageNumber: 1, count: 10}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;responses&quot; =&gt; %{ &quot;requestMetadata&quot; =&gt; %{ &quot;reason&quot; =&gt; &quot;Testing things...&quot; }, &quot;sourceType&quot; =&gt; &quot;Wallet&quot;, &quot;source&quot; =&gt; &quot;PaymentWallet&quot;, &quot;provider&quot; =&gt; &quot;Mpesa&quot;, &quot;destinationType&quot; =&gt; &quot;PhoneNumber&quot;, &quot;description&quot; =&gt; &quot;The service request is processed successfully.&quot;, &quot;providerChannel&quot; =&gt; &quot;824879&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 1.0000&quot;, &quot;providerRefId&quot; =&gt; &quot;SAMPLE_MPESA_CODE&quot;, &quot;providerMetadata&quot; =&gt; %{ &quot;recipientIsRegistered&quot; =&gt; &quot;true&quot;, &quot;recipientName&quot; =&gt; &quot;254724XXXYYY - John Doe&quot; }, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;productName&quot; =&gt; &quot;testing&quot;, &quot;category&quot; =&gt; &quot;MobileB2C&quot;, &quot;transactionDate&quot; =&gt; &quot;12.05.2018 21:46:13&quot;, &quot;destination&quot; =&gt; &quot;+254708663158&quot;, &quot;value&quot; =&gt; &quot;KES 2900.0000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_b9379b671fee8ccf24b2c74f94da0ceb&quot;, &quot;creationTime&quot; =&gt; &quot;2018-05-12 18:46:12&quot; } }}"},{"ref":"AtEx.Gateway.Payments.Query.FetchProductTransactions.html#process_result/1","title":"AtEx.Gateway.Payments.Query.FetchProductTransactions.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Query.FetchProductTransactions.html#t:option/0","title":"AtEx.Gateway.Payments.Query.FetchProductTransactions.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.html","title":"AtEx.Gateway.Payments.Query.FetchWalletTransactions","type":"module","doc":"Fetch your wallet transactions by sending a HTTP GET request to the following endpoint"},{"ref":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.html#fetch_wallet_transactions/1","title":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.fetch_wallet_transactions/1","type":"function","doc":"Fetch your wallet transactions by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: pageNumber - The number of the page you’d like to read results from. Please Note: This STARTS from 1 and NOT 0 count - The number of transaction results you would like for this query. Must be &gt; 1 and &lt; 1,000 and optional parameters startDate, endDate, categories, provider, status, source, destination and providerChannel For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffetch_wallet_transactions Example iex&gt;AtEx.Gateway.Payments.Query.FetchWalletTransactions.fetch_wallet_transactions(%{ pageNumber: 1, count: 10}) {:ok, %{ &quot;description&quot; =&gt; &quot;Success&quot;, &quot;responses&quot; =&gt; [ %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-13 13:46:08&quot;, &quot;description&quot; =&gt; &quot;MobileB2B Payment Request to Mine&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_2504d5f5d28256fa264e815518e3ab0d&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; }, %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-10 18:50:22&quot;, &quot;description&quot; =&gt; &quot;MobileB2C Payment Request to +254724540000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_5e635fa1099b4c7f69e63a0cbc3120c4&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; }, %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-01 15:18:33&quot;, &quot;description&quot; =&gt; &quot;MobileB2C Payment Request to +254724540000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_beeb0be6b1bff57ec8f32675fe3f6e72&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; } ], &quot;status&quot; =&gt; &quot;Success&quot; }}"},{"ref":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.html#process_result/1","title":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.html#t:option/0","title":"AtEx.Gateway.Payments.Query.FetchWalletTransactions.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Query.FindTransaction.html","title":"AtEx.Gateway.Payments.Query.FindTransaction","type":"module","doc":"Find a particular payment transaction by sending a HTTP GET request to the following endpoint"},{"ref":"AtEx.Gateway.Payments.Query.FindTransaction.html#find_transaction/1","title":"AtEx.Gateway.Payments.Query.FindTransaction.find_transaction/1","type":"function","doc":"Find a particular payment transaction by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: transactionId - ID of the transaction you would like to find. For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffind_transaction Example iex&gt;AtEx.Gateway.Payments.Query.FindTransaction.find_transaction(%{transactionId: &quot;ATPid_a58b61dc2bf556ff9c4b16e9f6e40795&quot;}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;data&quot; =&gt; %{ &quot;requestMetadata&quot; =&gt; %{ &quot;reason&quot; =&gt; &quot;Testing things...&quot; }, &quot;sourceType&quot; =&gt; &quot;Wallet&quot;, &quot;source&quot; =&gt; &quot;PaymentWallet&quot;, &quot;provider&quot; =&gt; &quot;Mpesa&quot;, &quot;destinationType&quot; =&gt; &quot;PhoneNumber&quot;, &quot;description&quot; =&gt; &quot;The service request is processed successfully.&quot;, &quot;providerChannel&quot; =&gt; &quot;824879&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 1.0000&quot;, &quot;providerRefId&quot; =&gt; &quot;SAMPLE_MPESA_CODE&quot;, &quot;providerMetadata&quot; =&gt; %{ &quot;recipientIsRegistered&quot; =&gt; &quot;true&quot;, &quot;recipientName&quot; =&gt; &quot;254724XXXYYY - John Doe&quot; }, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;productName&quot; =&gt; &quot;testing&quot;, &quot;category&quot; =&gt; &quot;MobileB2C&quot;, &quot;transactionDate&quot; =&gt; &quot;12.05.2018 21:46:13&quot;, &quot;destination&quot; =&gt; &quot;+254708663158&quot;, &quot;value&quot; =&gt; &quot;KES 2900.0000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_b9379b671fee8ccf24b2c74f94da0ceb&quot;, &quot;creationTime&quot; =&gt; &quot;2018-05-12 18:46:12&quot; } }}"},{"ref":"AtEx.Gateway.Payments.Query.FindTransaction.html#process_result/1","title":"AtEx.Gateway.Payments.Query.FindTransaction.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Query.FindTransaction.html#t:option/0","title":"AtEx.Gateway.Payments.Query.FindTransaction.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.Query.WalletBalance.html","title":"AtEx.Gateway.Payments.Query.WalletBalance","type":"module","doc":"Fetch your wallet balance by sending a HTTP GET request to the following endpoint"},{"ref":"AtEx.Gateway.Payments.Query.WalletBalance.html#balance/0","title":"AtEx.Gateway.Payments.Query.WalletBalance.balance/0","type":"function","doc":"Find a particular payment transaction by sending a HTTP GET request to the following endpoint Example iex&gt;AtEx.Gateway.Payments.Query.WalletBalance.balance() {:ok, %{&quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;status&quot; =&gt; &quot;Success&quot;}}"},{"ref":"AtEx.Gateway.Payments.Query.WalletBalance.html#process_result/1","title":"AtEx.Gateway.Payments.Query.WalletBalance.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.Query.WalletBalance.html#t:option/0","title":"AtEx.Gateway.Payments.Query.WalletBalance.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.TopupStash.html","title":"AtEx.Gateway.Payments.TopupStash","type":"module","doc":"This is the Topup stash module that implements APIs to allow you to move money from a Payment Product to an Africa’s Talking application stash. An application stash is the wallet that funds your service usage expences."},{"ref":"AtEx.Gateway.Payments.TopupStash.html#process_result/1","title":"AtEx.Gateway.Payments.TopupStash.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.TopupStash.html#topup/1","title":"AtEx.Gateway.Payments.TopupStash.topup/1","type":"function","doc":"Topup stash APIs allow you to move money from a Payment Product to an Africa’s Talking application stash. An application stash is the wallet that funds your service usage expences. Parameters map: - a map containing: productName Africa’s Talking Payment product to initiate this transaction. currencyCode 3-digit ISO format currency code for the value of this transaction (e.g KES, UGX, USD) amount Amount - in the provided currency - that the application will be topped up with. metadata A map of any metadata that you would like us to associate with the request. Use this field to send data that will map notifications to topup stash requests. It will be included in the notification we send once the topup stash request is completed. Example iex&gt; AtEx.Gateway.Payments.TopupStash.topup(%{ currencyCode: &quot;KES&quot;, amount: 1500, productName: &quot;AtEx&quot;, metadata: %{ message: &quot;I am here&quot;}}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;description&quot; =&gt; &quot;Topped up user stash. New Stash Balance: KES 1500.00&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_SampleTxnId123&quot; } }"},{"ref":"AtEx.Gateway.Payments.TopupStash.html#t:option/0","title":"AtEx.Gateway.Payments.TopupStash.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Payments.WalletTransfer.html","title":"AtEx.Gateway.Payments.WalletTransfer","type":"module","doc":"This module implements the Wallet transfer Africas Talking API endpoint to allow a user to transfer money from one Payment Product to another Payment Product hosted on Africa’s Talking."},{"ref":"AtEx.Gateway.Payments.WalletTransfer.html#process_result/1","title":"AtEx.Gateway.Payments.WalletTransfer.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Payments.WalletTransfer.html#transfer/1","title":"AtEx.Gateway.Payments.WalletTransfer.transfer/1","type":"function","doc":"Wallet transfer APIs allow you to transfer money from one Payment Product to another Payment Product hosted on Africa’s Talking. Parameters map: - a map containing: productName Africa’s Talking Payment product to initiate this transaction. targetProductCode Unique product code of the Africa’s Talking Payment Product to transfer the funds to. currencyCode 3-digit ISO format currency code for the value of this transaction (e.g KES, UGX, USD) amount Amount - in the provided currency - that the application will be topped up with. metadata A map of any metadata that you would like us to associate with the request. Use this field to send data that will map notifications to topup stash requests. It will be included in the notification we send once the topup stash request is completed. Example iex&gt; AtEx.Gateway.Payments.WalletTransfer.transfer(%{ currencyCode: &quot;KES&quot;, amount: 1500.00, productName: &quot;AtEx&quot;, targetProductCode: 564, metadata: %{ message: &quot;Electricity Bills&quot;}}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;description&quot; =&gt; &quot;Transfered funds to sandbox [TestProduct]&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_SampleTxnId123&quot; } }"},{"ref":"AtEx.Gateway.Payments.WalletTransfer.html#t:option/0","title":"AtEx.Gateway.Payments.WalletTransfer.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Sms.Bulk.html","title":"AtEx.Gateway.Sms.Bulk","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API SMS endpoint, use it to POST and GET requests to the SMS endpoint"},{"ref":"AtEx.Gateway.Sms.Bulk.html#fetch_sms/1","title":"AtEx.Gateway.Sms.Bulk.fetch_sms/1","type":"function","doc":"This function makes a get request to fetch an SMS via the Africa&#39;s talking SMS endpoint, this function accepts a map of parameters that optionally accepts lastReceivedId of the message. sent Parameters attrs: - an empty map or a map containing optionally lastReceivedId of the message to be fetched, see the docs at https://build.at-labs.io/docs/sms%2Ffetch_messages for how to use these keys Examples iex&gt; AtEx.Sms.fetch_sms(%{}) {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{ &quot;Messages&quot; =&gt; [ %{ &quot;linkId&quot; =&gt; &quot;SampleLinkId123&quot;, &quot;text&quot; =&gt; &quot;Hello&quot;, &quot;to&quot; =&gt; &quot;28901&quot;, &quot;id&quot; =&gt; 15071, &quot;date&quot; =&gt; &quot;2018-03-19T08:34:18.445Z&quot;, &quot;from&quot; =&gt; &quot;+254711XXXYYY&quot; } ] } } }"},{"ref":"AtEx.Gateway.Sms.Bulk.html#process_result/1","title":"AtEx.Gateway.Sms.Bulk.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Sms.Bulk.html#send_sms/1","title":"AtEx.Gateway.Sms.Bulk.send_sms/1","type":"function","doc":"This function builds and runs a post request to send an SMS via the Africa&#39;s talking SMS endpoint, this function accepts a map of parameters that should always contain the to address and the message to be sent Parameters attrs: - a map containing a to and message key optionally it may also contain from, bulkSMSMode, enqueue, keyword, linkId and retryDurationInHours keys, see the docs at https://build.at-labs.io/docs/sms%2Fsending for how to use these keys Examples iex&gt; AtEx.Sms.send_sms(%{to: &quot;+254721978097&quot;, message: &quot;Howdy&quot;}) {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{ &quot;Message&quot; =&gt; &quot;Sent to 1/1 Total Cost: ZAR 0.1124&quot;, &quot;Recipients&quot; =&gt; [ %{ &quot;cost&quot; =&gt; &quot;KES 0.8000&quot;, &quot;messageId&quot; =&gt; &quot;ATXid_a584c3fd712a00b7bce3c4b7b552ac56&quot;, &quot;number&quot; =&gt; &quot;+254721978097&quot;, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;statusCode&quot; =&gt; 101 } ] } }}"},{"ref":"AtEx.Gateway.Sms.Bulk.html#t:option/0","title":"AtEx.Gateway.Sms.Bulk.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html","title":"AtEx.Gateway.Sms.PremiumSubscriptions","type":"module","doc":""},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#create_subscription/1","title":"AtEx.Gateway.Sms.PremiumSubscriptions.create_subscription/1","type":"function","doc":"This function makes a post request to subscribe to premium sms content via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters. sent Config Add shortcode, and keyword to the AtEx configs Parameters attrs: - a map containing: phoneNumber - phone number to be subscribed Check https://build.at-labs.io/docs/sms%2Fpremium_subscriptions%2Fcreate Example iex&gt; AtEx.Gateway.Sms.PremiumSubscriptions.create_subscription(%{phoneNumber: &quot;+25471231111&quot;}) {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{&quot;Message&quot; =&gt; &quot;Sent to 1/1 Total Cost: ZAR 0.1124&quot;, &quot;Recipients&quot; =&gt; [%{&quot;cost&quot; =&gt; &quot;KES 0.8000&quot;, &quot;messageId&quot; =&gt; &quot;ATXid_a584c3fd712a00b7bce3c4b7b552ac56&quot;, &quot;number&quot; =&gt; &quot;+254728833181&quot;, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;statusCode&quot; =&gt; 101}]} }}"},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#delete_subscription/1","title":"AtEx.Gateway.Sms.PremiumSubscriptions.delete_subscription/1","type":"function","doc":"This function makes a POST request to delete sms subscriptions via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters: Parameters attrs: - a map containing: shortCode - premium short code mapped to your account keyword - premium keyword under the above short code mapped to your account phoneNumber - phone number to be unsubscribed Example iex&gt; AtEx.Gateway.Sms.PremiumSubscriptions.delete_subscription(%{ phoneNumber: &quot;+25471231111&quot;}) {:ok, %{&quot;description&quot; =&gt; &quot;Succeeded&quot;, &quot;status&quot; =&gt; &quot;Success&quot;}}"},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#fetch_subscriptions/0","title":"AtEx.Gateway.Sms.PremiumSubscriptions.fetch_subscriptions/0","type":"function","doc":"This function makes a GET request to fetch premium sms subscriptions via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters. sent Parameters attrs: - a map containing: shortCode - premium short code mapped to your account keyword - premium keyword under the above short code mapped to your account lastReceivedId - (optional) ID of the subscription you believe to be your last. Set it to 0 to for the first time. For more info, look at the docs here https://build.at-labs.io/docs/sms%2Fpremium_subscriptions%2Ffetch Example iex&gt; AtEx.Gateway.Sms.PremiumSubscriptions.fetch_subscriptions() {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{ &quot;Messages&quot; =&gt; [ %{ &quot;linkId&quot; =&gt; &quot;SampleLinkId123&quot;, &quot;text&quot; =&gt; &quot;Hello&quot;, &quot;to&quot; =&gt; &quot;28901&quot;, &quot;id&quot; =&gt; 15071, &quot;date&quot; =&gt; &quot;2018-03-19T08:34:18.445Z&quot;, &quot;from&quot; =&gt; &quot;+254711XXXYYY&quot; } ] } }}"},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#generate_checkout_token/1","title":"AtEx.Gateway.Sms.PremiumSubscriptions.generate_checkout_token/1","type":"function","doc":"This function fetches the checkout token from the checkout token endpoint THIS IS DIFFERENT THAN THE SMS ENDPOINT!! phone_number: - a string representing a valid phone number in EL64 (+ with all non digit characters removed) [NOTE: function does not verify the phone number is in any way correct before sending to the endpoint.] Returns a success tuple: {:ok, }} or {:error, }"},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#process_result/1","title":"AtEx.Gateway.Sms.PremiumSubscriptions.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Sms.PremiumSubscriptions.html#t:option/0","title":"AtEx.Gateway.Sms.PremiumSubscriptions.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Voice.CallTransfer.html","title":"AtEx.Gateway.Voice.CallTransfer","type":"module","doc":"This module has the call transfer functionality of AfricasTalking it allows you to transfer your call to another number by making a HTTP POST request to the Africas Talking voice endpoints."},{"ref":"AtEx.Gateway.Voice.CallTransfer.html#process_result/1","title":"AtEx.Gateway.Voice.CallTransfer.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Voice.CallTransfer.html#transfer/1","title":"AtEx.Gateway.Voice.CallTransfer.transfer/1","type":"function","doc":"This function makes a POST request to transfer a call to another number in the Africa&#39;s talking call endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: sessionId - Session Id of the ongoing call, it must have two legs phoneNumber - Phone Number to transfer the call to. callLeg - (optional) Call leg to transfer the call to either caller or callee(Defaults to callee) holdMusicUrl - (optional) The url of the media file to be played when the user is on hold. Don’t forget to start with http:// Example iex&gt; AtEx.Gateway.Voice.CallTransfer.transfer(%{ ...&gt; sessionId: &quot;ATVId_47ef478e918923e7b2d0921ebd5b66a6&quot;, ...&gt; phoneNumber: &quot;+254728900922&quot;, ...&gt; }) {:ok, %{&quot;callTransferResponse&quot; =&gt; %{&quot;errorMessage&quot; =&gt; &quot;None&quot;, &quot;status&quot; =&gt; &quot;Success&quot;}}}"},{"ref":"AtEx.Gateway.Voice.CallTransfer.html#t:option/0","title":"AtEx.Gateway.Voice.CallTransfer.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Voice.MakeCall.html","title":"AtEx.Gateway.Voice.MakeCall","type":"module","doc":""},{"ref":"AtEx.Gateway.Voice.MakeCall.html#call/1","title":"AtEx.Gateway.Voice.MakeCall.call/1","type":"function","doc":"This function makes a POST request to make a call via the Africa&#39;s talking call endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: from - your Africa’s Talking phone number (in international format i.e. +XXXYYYYYY) to - A comma separated string of recipients’ phone numbers. clientRequestId - (optional) Variable sent to your Events Callback URL that can be used to tag the call Example iex&gt; AtEx.Gateway.Voice.MakeCall.call(%{ ...&gt; to: &quot;+254728907896&quot;, ...&gt; from: &quot;+254728900922&quot;, ...&gt; }) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;phoneNumber&quot; =&gt; &quot;+254728907896&quot;, &quot;sessionId&quot; =&gt; &quot;ATVId_cb29c2b9fc27983827afc00786c4f9ea&quot;, &quot;status&quot; =&gt; &quot;Queued&quot; } ], &quot;errorMessage&quot; =&gt; &quot;None&quot; }}"},{"ref":"AtEx.Gateway.Voice.MakeCall.html#process_result/1","title":"AtEx.Gateway.Voice.MakeCall.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Voice.MakeCall.html#t:option/0","title":"AtEx.Gateway.Voice.MakeCall.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Voice.QueueStatus.html","title":"AtEx.Gateway.Voice.QueueStatus","type":"module","doc":""},{"ref":"AtEx.Gateway.Voice.QueueStatus.html#process_result/1","title":"AtEx.Gateway.Voice.QueueStatus.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Voice.QueueStatus.html#status/1","title":"AtEx.Gateway.Voice.QueueStatus.status/1","type":"function","doc":"This function makes a POST request to check the queue status of voice calls via the Africa&#39;s talking queue status endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: username - Your Africa’s Talking application username. Can be set in the config phoneNumbers - A comma separated list of one or more numbers mapped to your Africa’s Talking account. Example iex&gt; AtEx.Gateway.Voice.QueueStatus.status(%{ ...&gt; phoneNumbers: &quot;+254728833180, +254728907896&quot; ...&gt; }) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;phoneNumber&quot; =&gt; &quot;+254728833180&quot;, &quot;queueName&quot; =&gt; &quot;&quot;, &quot;numCalls&quot; =&gt; 1 }, %{ &quot;phoneNumber&quot; =&gt; &quot;+254728907896&quot;, &quot;queueName&quot; =&gt; &quot;&quot;, &quot;numCalls&quot; =&gt; 4 } ], &quot;errorMessage&quot; =&gt; &quot;None&quot;, &quot;status&quot; =&gt; &quot;Success&quot; }}"},{"ref":"AtEx.Gateway.Voice.QueueStatus.html#t:option/0","title":"AtEx.Gateway.Voice.QueueStatus.option/0","type":"type","doc":""},{"ref":"AtEx.Gateway.Voice.UploadMedia.html","title":"AtEx.Gateway.Voice.UploadMedia","type":"module","doc":""},{"ref":"AtEx.Gateway.Voice.UploadMedia.html#process_result/1","title":"AtEx.Gateway.Voice.UploadMedia.process_result/1","type":"function","doc":"Process results from calling the gateway"},{"ref":"AtEx.Gateway.Voice.UploadMedia.html#upload/1","title":"AtEx.Gateway.Voice.UploadMedia.upload/1","type":"function","doc":"This function makes a POST request to upload a media in the Africa&#39;s talking queue status endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: username - Your Africa’s Talking application username. Can be set in the config url - The url of the file to upload. Don’t forget to start with http:// Example iex&gt; AtEx.Gateway.Voice.UploadMedia.upload(%{ phoneNumber: &quot;+254728833180&quot;, ...&gt; url: &quot;https://www.soundhelix.com/examples/mp3/SoundHelix-Song-8.mp3&quot; ...&gt; }) {:ok, result}"},{"ref":"AtEx.Gateway.Voice.UploadMedia.html#t:option/0","title":"AtEx.Gateway.Voice.UploadMedia.option/0","type":"type","doc":""},{"ref":"AtEx.IoT.html","title":"AtEx.IoT","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API IoT endpoints"},{"ref":"AtEx.IoT.html#publish/1","title":"AtEx.IoT.publish/1","type":"function","doc":"This function makes a POST request to to publish messages to your remote devices through the Africa&#39;s talking IOT endpoint The function accepts a map of parameters. Parameters attrs: - a map containing: deviceGroup - The device group to which the message is to be sent topic - The messaging channel to which the message is to be sent. In the form // payload - The message packet to be sent to the subscribed devices. Example iex&gt; AtEx.IoT.publish(%{ ...&gt; deviceGroup: &quot;CrazyCats&quot;, ...&gt; topic: &quot;any-topic&quot;, ...&gt; payload: &quot;take me to your leader&quot; ...&gt; }) {:ok, %{ &quot;status&quot; =&gt; true, &quot;description&quot; =&gt; &quot;Message processed successfully&quot;}}"},{"ref":"AtEx.Payment.html","title":"AtEx.Payment","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API Payment endpoints"},{"ref":"AtEx.Payment.html#b2b_checkout/1","title":"AtEx.Payment.b2b_checkout/1","type":"function","doc":"Mobile Business To Business (B2B) APIs allow you to send payments to businesses e.g banks from your Payment Wallet. Config Add b2c_product_name key to your AtEx configs Parameters attrs: - a map containing a provider(Mpesa,TigoTanzania,Athena), transferType(BusinessBuyGoods,BusinessPayBill, DisburseFundsToBusiness, BusinessToBusinessTransfer), currencyCode amount, destinationChannel, destinationAccount and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fb2b for how to use these keys Example iex&gt;AtEx.Payment.b2b_checkout(%{provider: &quot;Athena&quot;, transferType: &quot;DisburseFundsToBusiness&quot;, amount: 10, currencyCode: &quot;KES&quot;, destinationChannel: &quot;Mine&quot;, destinationAccount: &quot;Mine&quot;, metadata: %{ message: &quot;I am here&quot;}}) {:ok, %{ &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;Queued&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_2504d5f5d28256fa264e815518e3ab0d&quot; }}"},{"ref":"AtEx.Payment.html#b2c_checkout/1","title":"AtEx.Payment.b2c_checkout/1","type":"function","doc":"This function initiates a mobile B2C request by making a HTTP POST request to the Africa&#39;s talking Mobile B2C endpoint. Config Add stk_product_name key to your AtEx configs Parameters attrs: - a list of Recipient each a map containing a phoneNumber, currencyCode, amount and a map of metadata key optionally it may also contain name, reason and providerChannel see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fb2c%2Foverview for how to use these keys Example iex&gt;AtEx.Payment.b2c_checkout([%{phoneNumber: &quot;254724540000&quot;, amount: 10, currencyCode: &quot;KES&quot;, metadata: %{ message: &quot;I am here&quot;}}]) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;phoneNumber&quot; =&gt; &quot;+254724540000&quot;, &quot;provider&quot; =&gt; &quot;Athena&quot;, &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;Queued&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_2b76da39eebd5c6bcc49e5d30c3d0390&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; } ], &quot;numQueued&quot; =&gt; 1, &quot;totalTransactionFee&quot; =&gt; &quot;KES 0.1000&quot;, &quot;totalValue&quot; =&gt; &quot;KES 10.0000&quot; }}"},{"ref":"AtEx.Payment.html#balance/0","title":"AtEx.Payment.balance/0","type":"function","doc":"Find a particular payment transaction by sending a HTTP GET request to the following endpoint Example iex&gt;AtEx.Gateway.Payments.Query.WalletBalance.balance() {:ok, %{&quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;status&quot; =&gt; &quot;Success&quot;}}"},{"ref":"AtEx.Payment.html#bank_checkout/1","title":"AtEx.Payment.bank_checkout/1","type":"function","doc":"Bank checkout APIs allow your application to collect money into your payment wallet by initiating transactions that deduct money from a customers bank account. Config Add bank_checkout_product_name key to your AtEx configs Parameters attrs: - a map containing bankAccount(a map), currencyCode, amount, narration and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Fcheckout for how to use these keys Example iex&gt;AtEx.Payment.bank_checkout(%{bankAccount: %{accountName: &quot;KCB&quot;, accountNumber: &quot;93892892&quot;, bankCode: 234001}, amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, metadata: %{detail: &quot;A Bill&quot;}}) {:ok, %{ &quot;description&quot; =&gt; &quot;Payment is pending validation by the user&quot;, &quot;status&quot; =&gt; &quot;PendingValidation&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_722a5dbaf1e8be4832614b523810dc29&quot; }}"},{"ref":"AtEx.Payment.html#bank_transfer/1","title":"AtEx.Payment.bank_transfer/1","type":"function","doc":"Bank checkout validation APIs allow your application to validate bank checkout charge requests. Config Add bank_transfer_product_name key to your AtEx configs Parameters attrs: - a list of recipients each containing a map with currencyCode, amount, narration and a map of metadata (optional) see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Ftransfer for how to use these keys Example iex&gt;AtEx.Payment.bank_transfer([%{bankAccount: %{accountName: &quot;KCB&quot;, accountNumber: &quot;93892892&quot;, bankCode: 234001}, amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, metadata: %{detail: &quot;A Bill&quot;}}]) {:ok, %{ &quot;entries&quot;: [%{ &quot;accountNumber&quot;: &quot;93892892&quot;, &quot;status&quot;: &quot;Queued&quot;, &quot;transactionId&quot;: &quot;ATPid_SampleTxnId&quot;, &quot;transactionFee&quot;: &quot;NGN 50.00&quot; }] }}"},{"ref":"AtEx.Payment.html#bank_validate/1","title":"AtEx.Payment.bank_validate/1","type":"function","doc":"Bank checkout validation APIs allow your application to validate bank checkout charge requests. Parameters attrs: - a map containing transactionId and otp see the docs at https://build.at-labs.io/docs/payments%2Fbank%2Fvalidate for how to use these keys Example iex&gt;AtEx.Payment.bank_validate(%{transactionId: &quot;ATPid_a58b61dc2bf556ff9c4b16e9f6e40795&quot;, otp: &quot;password&quot;}) {:ok, %{ &quot;status&quot;: &quot;Success&quot;, &quot;description&quot;: &quot;Payment completed successfully&quot; }}"},{"ref":"AtEx.Payment.html#card_checkout/1","title":"AtEx.Payment.card_checkout/1","type":"function","doc":"Card Checkout APIs allow your application to collect money into your Payment Wallet by initiating transactions that deduct money from a customers Debit or Credit Card. Config Add card_checkout_product_name key to your AtEx configs Parameters attrs: - a map containing either paymentCard(a map) or checkoutToken, currencyCode, amount, narration and a map of metadata(optional) see the docs at https://build.at-labs.io/docs/payments%2Fcard%2Fcheckout for how to use these keys Example iex&gt;AtEx.Payment.card_checkout(%{amount: 1000.00, currencyCode: &quot;KES&quot;, narration: &quot;Payment&quot;, paymentCard: %{number: &quot;10928873477387&quot;, cvvNumber: 253, expiryMonth: 12, expiryYear: 2020, countryCode: &quot;NG&quot;, authToken: &quot;jhdguyt6372gsu6q&quot;}}) {:ok, %{ status: &quot;PendingValidation&quot;, description: &quot;Waiting for user input&quot;, transactionId: &quot;ATPid_SampleTxnId123&quot; }}"},{"ref":"AtEx.Payment.html#card_validate/1","title":"AtEx.Payment.card_validate/1","type":"function","doc":"Card checkout validation APIs allow your application to validate card checkout charge requests. Parameters attrs: - a map containing transactionId and otp see the docs at https://build.at-labs.io/docs/payments%2Fcard%2Fvalidate for how to use these keys Example iex&gt;AtEx.Payment.card_validate(%{transactionId: &quot;ATPid_SampleTxnId123&quot;, otp: &quot;password&quot;}) {:ok, %{ &quot;status&quot;: &quot;Success&quot;, &quot;description&quot;: &quot;Payment completed successfully&quot;, &quot;checkoutToken&quot;: &quot;ATCdTkn_SampleCdTknId123&quot; }}"},{"ref":"AtEx.Payment.html#fetch_product_transactions/1","title":"AtEx.Payment.fetch_product_transactions/1","type":"function","doc":"Fetch transactions of a particular payment product by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: productName - The name of the payment product whose transactions you’d like to fetch. pageNumber - The number of the page you’d like to read results from. Please Note: This STARTS from 1 and NOT 0 count - The number of transaction results you would like for this query. Must be &gt; 1 and &lt; 1,000 and optional parameters startDate, endDate, category, provider, status, source, destination and providerChannel For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffetch_product_transactions Example iex&gt;AtEx.Payment.fetch_product_transactions(%{productName: &quot;AtEx&quot;, pageNumber: 1, count: 10}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;responses&quot; =&gt; %{ &quot;requestMetadata&quot; =&gt; %{ &quot;reason&quot; =&gt; &quot;Testing things...&quot; }, &quot;sourceType&quot; =&gt; &quot;Wallet&quot;, &quot;source&quot; =&gt; &quot;PaymentWallet&quot;, &quot;provider&quot; =&gt; &quot;Mpesa&quot;, &quot;destinationType&quot; =&gt; &quot;PhoneNumber&quot;, &quot;description&quot; =&gt; &quot;The service request is processed successfully.&quot;, &quot;providerChannel&quot; =&gt; &quot;824879&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 1.0000&quot;, &quot;providerRefId&quot; =&gt; &quot;SAMPLE_MPESA_CODE&quot;, &quot;providerMetadata&quot; =&gt; %{ &quot;recipientIsRegistered&quot; =&gt; &quot;true&quot;, &quot;recipientName&quot; =&gt; &quot;254724XXXYYY - John Doe&quot; }, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;productName&quot; =&gt; &quot;testing&quot;, &quot;category&quot; =&gt; &quot;MobileB2C&quot;, &quot;transactionDate&quot; =&gt; &quot;12.05.2018 21:46:13&quot;, &quot;destination&quot; =&gt; &quot;+254708663158&quot;, &quot;value&quot; =&gt; &quot;KES 2900.0000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_b9379b671fee8ccf24b2c74f94da0ceb&quot;, &quot;creationTime&quot; =&gt; &quot;2018-05-12 18:46:12&quot; } }}"},{"ref":"AtEx.Payment.html#fetch_wallet_transactions/1","title":"AtEx.Payment.fetch_wallet_transactions/1","type":"function","doc":"Fetch your wallet transactions by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: pageNumber - The number of the page you’d like to read results from. Please Note: This STARTS from 1 and NOT 0 count - The number of transaction results you would like for this query. Must be &gt; 1 and &lt; 1,000 and optional parameters startDate, endDate, categories, provider, status, source, destination and providerChannel For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffetch_wallet_transactions Example iex&gt;AtEx.Payment.fetch_wallet_transactions(%{ pageNumber: 1, count: 10}) {:ok, %{ &quot;description&quot; =&gt; &quot;Success&quot;, &quot;responses&quot; =&gt; [ %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-13 13:46:08&quot;, &quot;description&quot; =&gt; &quot;MobileB2B Payment Request to Mine&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_2504d5f5d28256fa264e815518e3ab0d&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; }, %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-10 18:50:22&quot;, &quot;description&quot; =&gt; &quot;MobileB2C Payment Request to +254724540000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_5e635fa1099b4c7f69e63a0cbc3120c4&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; }, %{ &quot;balance&quot; =&gt; &quot;KES 90.0000&quot;, &quot;category&quot; =&gt; &quot;Debit&quot;, &quot;date&quot; =&gt; &quot;2020-07-01 15:18:33&quot;, &quot;description&quot; =&gt; &quot;MobileB2C Payment Request to +254724540000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_beeb0be6b1bff57ec8f32675fe3f6e72&quot;, &quot;value&quot; =&gt; &quot;KES 10.0000&quot; } ], &quot;status&quot; =&gt; &quot;Success&quot; }}"},{"ref":"AtEx.Payment.html#find_transaction/1","title":"AtEx.Payment.find_transaction/1","type":"function","doc":"Find a particular payment transaction by sending a HTTP GET request to the following endpoint Parameters attrs: - a map containing: transactionId - ID of the transaction you would like to find. For more on how to use these keys https://build.at-labs.io/docs/payments%2Fquery%2Ffind_transaction Example iex&gt;AtEx.Payment.find_transaction(%{transactionId: &quot;ATPid_a58b61dc2bf556ff9c4b16e9f6e40795&quot;}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;data&quot; =&gt; %{ &quot;requestMetadata&quot; =&gt; %{ &quot;reason&quot; =&gt; &quot;Testing things...&quot; }, &quot;sourceType&quot; =&gt; &quot;Wallet&quot;, &quot;source&quot; =&gt; &quot;PaymentWallet&quot;, &quot;provider&quot; =&gt; &quot;Mpesa&quot;, &quot;destinationType&quot; =&gt; &quot;PhoneNumber&quot;, &quot;description&quot; =&gt; &quot;The service request is processed successfully.&quot;, &quot;providerChannel&quot; =&gt; &quot;824879&quot;, &quot;transactionFee&quot; =&gt; &quot;KES 1.0000&quot;, &quot;providerRefId&quot; =&gt; &quot;SAMPLE_MPESA_CODE&quot;, &quot;providerMetadata&quot; =&gt; %{ &quot;recipientIsRegistered&quot; =&gt; &quot;true&quot;, &quot;recipientName&quot; =&gt; &quot;254724XXXYYY - John Doe&quot; }, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;productName&quot; =&gt; &quot;testing&quot;, &quot;category&quot; =&gt; &quot;MobileB2C&quot;, &quot;transactionDate&quot; =&gt; &quot;12.05.2018 21:46:13&quot;, &quot;destination&quot; =&gt; &quot;+254708663158&quot;, &quot;value&quot; =&gt; &quot;KES 2900.0000&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_b9379b671fee8ccf24b2c74f94da0ceb&quot;, &quot;creationTime&quot; =&gt; &quot;2018-05-12 18:46:12&quot; } }}"},{"ref":"AtEx.Payment.html#mobile_checkout/1","title":"AtEx.Payment.mobile_checkout/1","type":"function","doc":"This function initiates a mobile checkout request by sending a HTTP POST request to the Africa&#39;s talking Mobile Checkout endpoint. Parameters attrs: - a map containing a phoneNumber, currencyCode and amount key optionally it may also contain providerChannel and a map of metadata see the docs at https://build.at-labs.io/docs/payments%2Fmobile%2Fcheckout for how to use these keys Example iex&gt;AtEx.Payment.mobile_checkout(%{phoneNumber: &quot;254724540000&quot;, amount: 10, currencyCode: &quot;KES&quot;}) %{ &quot;description&quot; =&gt; &quot;Waiting for user input&quot;, &quot;providerChannel&quot; =&gt; &quot;525900&quot;, &quot;status&quot; =&gt; &quot;PendingConfirmation&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_bbd0bcd713e27d9201807076c6db0ed5&quot; }"},{"ref":"AtEx.Payment.html#topup/1","title":"AtEx.Payment.topup/1","type":"function","doc":"Topup stash APIs allow you to move money from a Payment Product to an Africa’s Talking application stash. An application stash is the wallet that funds your service usage expences. Parameters map: - a map containing: productName Africa’s Talking Payment product to initiate this transaction. currencyCode 3-digit ISO format currency code for the value of this transaction (e.g KES, UGX, USD) amount Amount - in the provided currency - that the application will be topped up with. metadata A map of any metadata that you would like us to associate with the request. Use this field to send data that will map notifications to topup stash requests. It will be included in the notification we send once the topup stash request is completed. Example iex&gt; AtEx.Payment.topup(%{ currencyCode: &quot;KES&quot;, amount: 1500, productName: &quot;AtEx&quot;, metadata: %{ message: &quot;I am here&quot;}}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;description&quot; =&gt; &quot;Topped up user stash. New Stash Balance: KES 1500.00&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_SampleTxnId123&quot; } }"},{"ref":"AtEx.Payment.html#transfer/1","title":"AtEx.Payment.transfer/1","type":"function","doc":"Wallet transfer APIs allow you to transfer money from one Payment Product to another Payment Product hosted on Africa’s Talking. Parameters map: - a map containing: productName Africa’s Talking Payment product to initiate this transaction. targetProductCode Unique product code of the Africa’s Talking Payment Product to transfer the funds to. currencyCode 3-digit ISO format currency code for the value of this transaction (e.g KES, UGX, USD) amount Amount - in the provided currency - that the application will be topped up with. metadata A map of any metadata that you would like us to associate with the request. Use this field to send data that will map notifications to topup stash requests. It will be included in the notification we send once the topup stash request is completed. Example iex&gt; AtEx.Payment.transfer(%{ currencyCode: &quot;KES&quot;, amount: 1500.00, productName: &quot;AtEx&quot;, targetProductCode: 564, metadata: %{ message: &quot;Electricity Bills&quot;}}) {:ok, %{ &quot;status&quot; =&gt; &quot;Success&quot;, &quot;description&quot; =&gt; &quot;Transfered funds to sandbox [TestProduct]&quot;, &quot;transactionId&quot; =&gt; &quot;ATPid_SampleTxnId123&quot; } }"},{"ref":"AtEx.Sms.html","title":"AtEx.Sms","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API SMS endpoints"},{"ref":"AtEx.Sms.html#create_subscription/1","title":"AtEx.Sms.create_subscription/1","type":"function","doc":"This function makes a post request to subscribe to premium sms content via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters. sent Config Add shortcode, and keyword to the AtEx configs Parameters attrs: - a map containing: phoneNumber - phone number to be subscribed Check https://build.at-labs.io/docs/sms%2Fpremium_subscriptions%2Fcreate Example iex&gt; AtEx.Sms.create_subscription(%{phoneNumber: &quot;+25471231111&quot;}) {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{&quot;Message&quot; =&gt; &quot;Sent to 1/1 Total Cost: ZAR 0.1124&quot;, &quot;Recipients&quot; =&gt; [%{&quot;cost&quot; =&gt; &quot;KES 0.8000&quot;, &quot;messageId&quot; =&gt; &quot;ATXid_a584c3fd712a00b7bce3c4b7b552ac56&quot;, &quot;number&quot; =&gt; &quot;+254728833181&quot;, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;statusCode&quot; =&gt; 101}]} }}"},{"ref":"AtEx.Sms.html#delete_subscription/1","title":"AtEx.Sms.delete_subscription/1","type":"function","doc":"This function makes a POST request to delete sms subscriptions via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters: Parameters attrs: - a map containing: shortCode - premium short code mapped to your account keyword - premium keyword under the above short code mapped to your account phoneNumber - phone number to be unsubscribed Example iex&gt; AtEx.Sms.delete_subscription(%{ phoneNumber: &quot;+25471231111&quot;}) {:ok, %{&quot;description&quot; =&gt; &quot;Succeeded&quot;, &quot;status&quot; =&gt; &quot;Success&quot;}}"},{"ref":"AtEx.Sms.html#fetch_sms/1","title":"AtEx.Sms.fetch_sms/1","type":"function","doc":"This function makes a get request to fetch an SMS via the Africa&#39;s talking SMS endpoint, this function accepts an map of parameters that optionally accepts lastReceivedId of the message. sent Parameters map: an empty map or a map containing optionally lastReceivedId of the message to be fetched Examples iex&gt; AtEx.Sms.fetch_sms(%{}) {:ok, %{&quot;SMSMessageData&quot; =&gt; %{&quot;Messages&quot; =&gt; [] } } }"},{"ref":"AtEx.Sms.html#fetch_subscriptions/0","title":"AtEx.Sms.fetch_subscriptions/0","type":"function","doc":"This function makes a GET request to fetch premium sms subscriptions via the Africa&#39;s talking subscription endpoint, this function accepts an map of parameters. sent Parameters attrs: - a map containing: shortCode - premium short code mapped to your account keyword - premium keyword under the above short code mapped to your account lastReceivedId - (optional) ID of the subscription you believe to be your last. Set it to 0 to for the first time. Example iex&gt; AtEx.Sms.fetch_subscriptions() {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{ &quot;Messages&quot; =&gt; [ %{ &quot;linkId&quot; =&gt; &quot;SampleLinkId123&quot;, &quot;text&quot; =&gt; &quot;Hello&quot;, &quot;to&quot; =&gt; &quot;28901&quot;, &quot;id&quot; =&gt; 15071, &quot;date&quot; =&gt; &quot;2018-03-19T08:34:18.445Z&quot;, &quot;from&quot; =&gt; &quot;+254711XXXYYY&quot; } ] } }}"},{"ref":"AtEx.Sms.html#send_sms/1","title":"AtEx.Sms.send_sms/1","type":"function","doc":"This function builds and runs a post request to send an SMS via the Africa&#39;s talking SMS endpoint, this function accepts a map of parameters that should always contain the to address and the message to be sent Parameters map: a map containing a to and message key optionally it may also contain from, bulk_sms, enqueue, key_word link_id and retry_hours keys, see the docs at https://build.at-labs.io/docs/sms%2Fsending for how to use these keys Examples iex&gt; AtEx.Sms.send_sms(%{to: &quot;+254728833181&quot;, message: &quot;Howdy&quot;}) {:ok, %{ &quot;SMSMessageData&quot; =&gt; %{ &quot;Message&quot; =&gt; &quot;Sent to 1/1 Total Cost: ZAR 0.1124&quot;, &quot;Recipients&quot; =&gt; [ %{ &quot;cost&quot; =&gt; &quot;KES 0.8000&quot;, &quot;messageId&quot; =&gt; &quot;ATXid_96e52a761a82c1bad58e885109224aad&quot;, &quot;number&quot; =&gt; &quot;+254728833181&quot;, &quot;status&quot; =&gt; &quot;Success&quot;, &quot;statusCode&quot; =&gt; 101 } ] } }}"},{"ref":"AtEx.USSD.html","title":"AtEx.USSD","type":"module","doc":"Overview USSD interation with the Africas Talking API is rather simple as documented in their documentation. Whenever a user sends a USSD request, it is received by Africastalking which then sends it as a POST request to your application through the callback URL you specified. This callback URL is specified on the Africastalking dashboard, under USSD section. When you receive the request, you consume it as you deem fit then generate a response. To generate the response, you can use the function AtEx.USSD.build_response/1 or AtEx.USSD.build_response/2. End session If you want to end a USSD session you call the AtEx.USSD.build_response/1 giving it a string and the :end. This will generate a string that indicates to Africastalking to end the current session while showing the provided string as the message to the user. Continue session when content is a string Incase you would like to cont with a USSD session, call the AtEx.USSD.build_response/1, giving it a string only since it already takes in the :cont as its second parameter by default. To display a response that awaits user input you can give the function a title and a body. The title is considered as description or instruction of the body. The body in most cases is a list of options a user will choose from. Example iex&gt; AtEx.USSD.build_response(&quot;What do you want to order&quot;, [&quot;Chips &amp; Sausage&quot;, &quot;Burger &amp; Chips&quot;, &quot;Rice &amp; beans&quot;]) {:ok, &quot;CON What do you want to order\\n1. Chips &amp; Sausage\\n2. Burger &amp; Chips\\n3. Rice &amp; beans&quot; } If you do not want to include a title of the response, give a list of strings to the function. The response will give back a string with the elements of the list labeled from 1 to the number of the last item Example iex&gt; AtEx.USSD.build_response([&quot;Chips &amp; Sausage&quot;, &quot;Burger &amp; Chips&quot;, &quot;Rice &amp; beans&quot;]) {:ok, &quot;CON 1. Chips &amp; Sausage\\n2. Burger &amp; Chips\\n3. Rice &amp; beans&quot; } The numbering of the body content can be changed to your preference by passing the number together with the item as a tuple. Once you use the tuple, all the elements of the list must be a tuple Example iex&gt; body = [{0,&quot;Chips &amp; Sausage&quot;}, {1, &quot;Burger &amp; Chips&quot;}, {2, &quot;Rice &amp; beans&quot;}] iex&gt; AtEx.USSD.build_response(body) {:ok, &quot;CON 0. Chips &amp; Sausage\\n1. Burger &amp; Chips\\n2. Rice &amp; beans&quot; }"},{"ref":"AtEx.USSD.html#build_response/1","title":"AtEx.USSD.build_response/1","type":"function","doc":"Gives us back a session end or a list of elements to be displayed to the user. It expects a string, a list of strings or a list of tuples as its input. Empty list will return an error"},{"ref":"AtEx.USSD.html#build_response/2","title":"AtEx.USSD.build_response/2","type":"function","doc":"Expected inputs message content body intent(either :end or :cont) The function can take in either the message and the content body as a list or the message and the intent as an atom. When given the content body(as the second argument) it returns valid africastalking session continuation with a message and a list of options to the user When given the intent(as the second argument) as :con, it returns a valid africastalking session continuation with a message only, otherwise whe given :end, it returns a message to end the session."},{"ref":"AtEx.Voice.html","title":"AtEx.Voice","type":"module","doc":"This module holds the implementation for the HTTP Gateway that runs calls against the Africas Talking API Voice endpoints"},{"ref":"AtEx.Voice.html#call/1","title":"AtEx.Voice.call/1","type":"function","doc":"This function makes a POST request to make a call via the Africa&#39;s talking call endpoint, through delegation this function accepts a map of parameters. sent Config Add b2b_product_name key to the AtEx config values Parameters attrs: - a map containing: from - your Africa’s Talking phone number (in international format i.e. +XXXYYYYYY) to - A comma separated string of recipients’ phone numbers. clientRequestId - (optional) Variable sent to your Events Callback URL that can be used to tag the call Example iex&gt; AtEx.Voice.call(%{ ...&gt; to: &quot;+254728907896&quot;, ...&gt; from: &quot;+254728900922&quot;, ...&gt; }) {:ok, result}"},{"ref":"AtEx.Voice.html#status/1","title":"AtEx.Voice.status/1","type":"function","doc":"This function makes a POST request to check the queue status of voice calls via the Africa&#39;s talking queue status endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: username - Your Africa’s Talking application username. Can be set in the config phoneNumbers - A comma separated list of one or more numbers mapped to your Africa’s Talking account. Example iex&gt; AtEx.Voice.status(%{ ...&gt; phoneNumbers: &quot;+254728833180, +254728907896&quot; ...&gt; }) {:ok, %{ &quot;entries&quot; =&gt; [ %{ &quot;phoneNumber&quot; =&gt; &quot;+254728833180&quot;, &quot;queueName&quot; =&gt; &quot;&quot;, &quot;numCalls&quot; =&gt; 1 }, %{ &quot;phoneNumber&quot; =&gt; &quot;+254728907896&quot;, &quot;queueName&quot; =&gt; &quot;&quot;, &quot;numCalls&quot; =&gt; 4 } ], &quot;errorMessage&quot; =&gt; &quot;None&quot;, &quot;status&quot; =&gt; &quot;Success&quot; }}"},{"ref":"AtEx.Voice.html#transfer/1","title":"AtEx.Voice.transfer/1","type":"function","doc":"This function makes a POST request to transfer a call to another number in the Africa&#39;s talking call endpoint, this function accepts a map of parameters. sent Parameters attrs: - a map containing: sessionId - Session Id of the ongoing call, it must have two legs phoneNumber - Phone Number to transfer the call to. callLeg - (optional) Call leg to transfer the call to either caller or callee(Defaults to callee) holdMusicUrl - (optional) The url of the media file to be played when the user is on hold. Don’t forget to start with http:// Example iex&gt; AtEx.Voice.transfer(%{ ...&gt; sessionId: &quot;ATVId_47ef478e918923e7b2d0921ebd5b66a6&quot;, ...&gt; phoneNumber: &quot;+254728900922&quot;, ...&gt; }) {:ok, result}"}]